#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    setContextMenuPolicy(Qt::CustomContextMenu);

    connect(this, SIGNAL(customContextMenuRequested(const QPoint &)),
            this, SLOT(slotShowContextMenu(const QPoint &)));
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::mousePressEvent(QMouseEvent *event)
{
    qDebug() << "Mouse button pressed" << event->button();
}

void MainWindow::mouseReleaseEvent(QMouseEvent *event)
{
    qDebug() << "Mouse button released" << event->button();
}

void MainWindow::slotShowContextMenu(const QPoint &pos)
{
    qDebug() << "Show context menu : " << pos;

    QPoint posMenu = pos; // non-const QPoint
    QMenu contextMenu(tr("Context menu"), this);

    QAction *action1 = contextMenu.addAction("Action1");
    QAction *action2 = contextMenu.addAction("Action2");

    connect(action1, SIGNAL(triggered()),
            this, SLOT(slotItemMenu1Clicked()));
    connect(action2, SIGNAL(triggered()),
            this, SLOT(slotItemMenu2Clicked()));

    connect(&contextMenu, SIGNAL(aboutToHide()),
            this, SLOT(slotContextMenuClosed()));

    contextMenu.exec(mapToGlobal(posMenu));
}

void MainWindow::slotItemMenu1Clicked()
{
    qDebug() << "Menu action 1 triggered";
}

void MainWindow::slotItemMenu2Clicked()
{
    qDebug() << "Menu action 2 triggered";
}

void MainWindow::slotContextMenuClosed()
{
    qDebug() << "Close context menu";
}


